classification
Title: xml.dom.Attr.name is not labeled as read-only
Type: Stage: patch review
Components: Documentation, Library (Lib), XML Versions: Python 3.8, Python 3.7
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: docs@python Nosy List: cheryl.sabella, dillona, docs@python, epicfaace, ezio.melotti, potomak, scoder, terry.reedy, urjitsb87
Priority: normal Keywords: easy, patch

Created on 2011-10-08 04:18 by dillona, last changed 2019-07-13 22:51 by potomak.

Pull Requests
URL Status Linked Edit
PR 14757 open potomak, 2019-07-13 22:45
Messages (10)
msg145155 - (view) Author: Dillon Amburgey (dillona) Date: 2011-10-08 04:18
http://docs.python.org/library/xml.dom.html#dom-attr-objects does not label the name attribute as read-only (like localName) even though it is.
msg145156 - (view) Author: Dillon Amburgey (dillona) Date: 2011-10-08 04:19
The behavior can be verified as follows. Notice that despite changing the value, the output XML does not change

>>> from xml.dom import minidom, Node
>>> a = minidom.parseString("<a href=\"http://asd.com\">asd</a>")
>>> a
<xml.dom.minidom.Document instance at 0x22d7c68>
>>> a.childNodes
[<DOM Element: a at 0x22d7d88>]
>>> a.childNodes[0]
<DOM Element: a at 0x22d7d88>
>>> a.childNodes[0].attributes
<xml.dom.minidom.NamedNodeMap object at 0x21caa70>
>>> a.childNodes[0].attributes.item(0)
<xml.dom.minidom.Attr instance at 0x22d7f38>
>>> a.childNodes[0].attributes.item(0).name
u'href'
>>> attr = a.childNodes[0].attributes.item(0)
>>> attr.name = "ad"
>>> a.toxml()
u'<?xml version="1.0" ?><a href="http://asd.com">asd</a>'
>>> attr.value = "asd"
>>> a.toxml()
u'<?xml version="1.0" ?><a href="asd">asd</a>'
msg145282 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2011-10-09 21:48
localName is defined with defproperty() in Lib/xml/dom/minidom.py:464 and looking at the definition of defproperty() in  Lib/xml/dom/minicompat.py:97 I think this is supposed to raise an xml.dom.NoModificationAllowedErr exception when someone tries to write on the attribute.  This doesn't seem to happen though.
OTOH 'name' doesn't use defproperty(), so technically it's writable, expect that writing on it has no effect.
This should still be documented, and it would also be good to figure out what's going on with defproperty().
msg145567 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2011-10-14 22:27
The docs are unchanged in 3.2. I presume the behavior is also.
msg148788 - (view) Author: Urjit Bhatia (urjitsb87) Date: 2011-12-03 09:56
Using the same code example as above, I added a simple print statement in the set method being defined in the defproperty and it fired correctly for -

a.childNodes[0].attributes='something'
**My print statement:**in defproperty set for name: attributes
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "/home/urjit/code/mercurial/python/cpython/Lib/xml/dom/minicompat.py", line 106, in set
    "attempt to modify read-only attribute " + repr(name))
xml.dom.NoModificationAllowedErr: attempt to modify read-only attribute 'attributes'

The getter seems to work fine for localName but the setter somehow does not fire.

I have a fix for this but when I am running the test on my ubuntu vm, it doesnt go beyond test_sndhdr. However, when I run that test directly, it is successful. I can submit a patch if this problem is fixed.
msg333081 - (view) Author: Ashwin Ramaswami (epicfaace) * Date: 2019-01-05 23:18
This behavior appears to be working as expected per the documentation when using Python 3.7.1. I am able to change name, but changing localName gives me a NoModificationAllowedErr error.
msg340206 - (view) Author: Cheryl Sabella (cheryl.sabella) * (Python committer) Date: 2019-04-14 13:11
Stefan,

Do you think this should be documented?
msg340211 - (view) Author: Stefan Behnel (scoder) * (Python committer) Date: 2019-04-14 14:14
The intended interface seems to be to change .name rather than .localName, so yes, that should be documented somewhere.

The implementation seems a bit funny in that a "self._localName", if set, takes precedence, but there doesn't seem to be an official way to set it. The Attr() constructor even takes a "localname" argument, which it then ignores. o_O
msg346582 - (view) Author: Giovanni Cappellotto (potomak) * Date: 2019-06-26 03:51
I took a quick look at `minidom.py` and `test_minidom.py`. It seems that you should always use `doc.renameNode(attr, namespace, new_name)` for renaming an attribute (or an element).

When `doc.renameNode` is applied on an attribute node, it removes the attribute from the `ownerElement` and re-set it after renaming it.

For instance:

```
>>> import xml.dom.minidom
>>> from xml.dom import minidom
>>> doc = minidom.parseString("<a href=\"http://foo.com\">foo</a>")
>>> attr = doc.childNodes[0].attributes.item(0)
>>> doc.renameNode(attr, xml.dom.EMPTY_NAMESPACE, "bar")
<xml.dom.minidom.Attr object at 0x7fb27d7ddb00>
>>> doc.toxml()
'<?xml version="1.0" ?><a bar="http://foo.com">foo</a>'
```

I agree that this behavior should be documented somewhere.

Maybe there should be a note/warning in the `name` attribute description. It should says that resetting an attribute `name` won't change the document representation and that `doc.renameNode` should be used instead.

Another approach may be to update the `name` setter implementation to remove and then re-set the attribute in the `ownerElement`.

What do you think it's the best approach:

1. update the doc
2. update the `name` setter implementation

I'd be happy to help to fix this issue.
msg347860 - (view) Author: Giovanni Cappellotto (potomak) * Date: 2019-07-13 22:51
In https://github.com/python/cpython/pull/14757 I tried updating the implementation of `Attr._set_name` to remove and reset the attr node in the owner element. So now `Attr._set_name` behaves similarly to `Document.renameNode`.

All existing tests are still passing and I added one more test for checking the issue described here.
History
Date User Action Args
2019-07-13 22:51:14potomaksetmessages: + msg347860
2019-07-13 22:45:40potomaksetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request14552
2019-06-26 03:51:49potomaksetnosy: + potomak
messages: + msg346582
2019-04-14 14:14:24scodersetstage: test needed -> needs patch
messages: + msg340211
components: + XML
versions: + Python 3.8
2019-04-14 13:11:34cheryl.sabellasetnosy: + cheryl.sabella, scoder
messages: + msg340206
2019-01-05 23:18:26epicfaacesetnosy: + epicfaace

messages: + msg333081
versions: + Python 3.7, - Python 2.7, Python 3.2, Python 3.3
2011-12-03 09:56:30urjitsb87setnosy: + urjitsb87
messages: + msg148788
2011-10-14 22:27:24terry.reedysetnosy: + terry.reedy

messages: + msg145567
versions: + Python 3.2, Python 3.3
2011-10-09 21:48:41ezio.melottisetcomponents: + Library (Lib)
versions: + Python 2.7
keywords: + easy
nosy: + ezio.melotti

messages: + msg145282
stage: test needed
2011-10-08 04:19:34dillonasetmessages: + msg145156
2011-10-08 04:18:11dillonacreate